/****************************************************************************/
// THIS PROGRAM IS PROVIDED "AS IS". ELPROTRONIC INC. MAKES NO WARRANTIES OR
// REPRESENTATIONS, EITHER EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS 
// FOR A PARTICULAR PURPOSE, LACK OF VIRUSES, ACCURACY OR 
// COMPLETENESS OF RESPONSES, RESULTS AND LACK OF NEGLIGENCE. 
// ELPROTRONIC INC. DISCLAIMS ANY WARRANTY OF TITLE, QUIET ENJOYMENT, QUIET 
// POSSESSION, AND NON-INFRINGEMENT OF ANY THIRD PARTY 
// INTELLECTUAL PROPERTY RIGHTS WITH REGARD TO THE PROGRAM OR 
// YOUR USE OF THE PROGRAM.
//
// IN NO EVENT SHALL ELPROTRONIC INC. BE LIABLE FOR ANY SPECIAL, INCIDENTAL, 
// CONSEQUENTIAL OR INDIRECT DAMAGES, HOWEVER CAUSED, ON ANY 
// THEORY OF LIABILITY AND WHETHER OR NOT ELPROTRONIC INC. HAS BEEN ADVISED 
// OF THE POSSIBILITY OF SUCH DAMAGES, ARISING IN ANY WAY OUT 
// OF THIS AGREEMENT, THE PROGRAM, OR YOUR USE OF THE PROGRAM. 
// EXCLUDED DAMAGES INCLUDE, BUT ARE NOT LIMITED TO, COST OF 
// REMOVAL OR REINSTALLATION, COMPUTER TIME, LABOR COSTS, LOSS 
// OF GOODWILL, LOSS OF PROFITS, LOSS OF SAVINGS, OR LOSS OF 
// USE OR INTERRUPTION OF BUSINESS. 
//
// Unless otherwise stated, the Program written and copyrighted 
// by Elprotronic Inc. is distributed as "freeware".  You may, 
// only under Elprotronic's Inc. copyright in the Program, use and modify the 
// Program without any charge or restriction.  You may 
// distribute to third parties, provided that you transfer a 
// copy of this license to the third party and the third party 
// agrees to these terms by its first use of the Program. You 
// must reproduce the copyright notice and any other legend of 
// ownership on each copy or partial copy, of the Program.
//
// You acknowledge and agree that the Program contains 
// copyrighted material, trade secrets and other Elprotronic Inc. proprietary 
// information and is protected by copyright laws, 
// international copyright treaties, and trade secret laws, as 
// well as other intellectual property laws.  To protect Elprotronic's Inc. 
// rights in the Program, you agree not to decompile, reverse 
// engineer, disassemble or otherwise translate any object code 
// versions of the Program to a human-readable form.  You agree 
// that in no event will you alter, remove or destroy any 
// copyright notice included in the Program.  Elprotronic Inc. reserves all 
// rights not specifically granted under this license. Except 
// as specifically provided herein, nothing in this agreement 
// shall be construed as conferring by implication, estoppel, 
// or otherwise, upon you, any license or other right under any 
// Elprotronic Inc. patents, copyrights or trade secrets.
//
/****************************************************************************/

#ifndef GENERIC_FPA_H
#define GENERIC_FPA_H

typedef unsigned char BYTE;
typedef int INT_X;

#ifdef __GNUC__
typedef unsigned long long ULONG64;
#else
typedef unsigned _int64   ULONG64;
#endif

namespace GenericFPA 
{	
	public ref class GenericFPAFuncs
	{
	public:		
		//Definitions
		literal		int GenericDLL_VERSION = 0x0173;

		literal		int CONFSEL_VALIDATE = 0;
		literal		int CONFSEL_VALUE = 1;
		literal		int CONFSEL_MIN = 2;
		literal		int CONFSEL_MAX = 3;
		literal		int CONFSEL_DEFAULT = 4;

		literal		int REPORT_MESSAGE_MAX_SIZE = 2000;
		literal		int MAX_TARGET_DEVICE_NUMBER = 6;
		literal		int MAX_USB_DEV_NUMBER = 64;
		literal		int MAX_FPA_INDEX = 64;
		literal		int ALL_ACTIVE_FPA = 0;
		literal		int FPA_UNMATCHED_RESULTS = -1;
		literal		int FPA_INVALID_NO = -2;
		literal		int ANY_FPA = -4;
		literal		int FPA_TIMEOUT_RESTART_SUCCESS = -16;
		literal		int FPA_TIMEOUT_RESTART_FAILURE = -32;


		literal		int PRG_ADAPTER_NOT_DETECTED = 4;
		literal		int TERMINATED_VCC_TOO_LOW = 0x20;
		literal		int CODE_IN_ROM = 0x10;
		literal		int CODE_IN_RAM = 0x20;
		literal		int CODE_OUT_OF_FLASH = 0x40;
		literal		int CODE_OVERWRITTEN = 0x80;
		literal		int PASSWORD_NOT_FOUND = 0x100;
		literal		int INVALID_CODE_FILE = 0x200;
		literal		int OPEN_FILE_OR_READ_ERR = 0x8;
		literal		int FILE_TI_FORMAT = 1;
		literal		int FILE_MOTOROLA_FORMAT = 2;
		literal		int FILE_INTEL_FORMAT = 3;
		literal		System::String^ FILE_TI_EXT = "txt";
		literal		System::String^ FILE_MOTOROLA_EXT = "s19";		
		literal		System::String^ FILE_MOTOROLA_EXT2 = "s28";
		literal		System::String^ FILE_MOTOROLA_EXT3 = "s37";
		literal		System::String^ FILE_INTEL_EXT = "hex";	


		literal		System::String^ C2000_DLL_TYPE = "C2000";
		literal		System::String^ CC_DLL_TYPE = "CC";
		literal		System::String^ CC_GP_DLL_TYPE = "CC-GP";
		literal		System::String^ ARM_DLL_TYPE = "ARM";
		literal		System::String^ ARM_GP_DLL_TYPE = "ARM-GP";
		literal		System::String^ MSP_DLL_TYPE = "MSP";
		literal		System::String^ MSP_GP_DLL_TYPE = "MSP-GP";
		literal		System::String^ FPM_DLL_TYPE = "M";
		literal		System::String^ GPM_DLL_TYPE = "M-GP";
		literal		System::String^ IMOTION_DLL_TYPE = "IMOTION";
		literal		System::String^ IMOTION_GP_DLL_TYPE = "IMOTION-GP";

		literal		int GANG_SIZE = 6;

		//static	INT_X	F_Get_FPA_Label(BYTE fpa, BYTE * label);
		literal		int FPA_LABEL_SIZE = 80;
		literal		int ADAPTER_HARDWARE_PN_SIZE = 16;
		literal		int ADAPTER_DESCRIPTION_SIZE = 32;

		//static  INT_X   F_Get_Power_Results(double *xs_adc);
		literal		int	XS_ADC_NUM_MEMBERS = 13;

		//dll_call_status is set after each invocation of this top-DLL.  Sub-DLL return values are passed using normal return statement.
		//ELP_CALLED - specific DLL function is implemented and was called, but says nothing about function working/not working
		//ELP_BUSY - DLL is busy serving another thread
		//ELP_IMPL - specific DLL function is implemented for this DLL type (returned instead of ELP_CALLED if debug_mode == 1)
		//ELP_ENOTIMP - specific DLL function is not implemented for this DLL type
		//ELP_ERANGE - thread info block wants DLL index out of range
		//ELP_ENOINIT - DLL specified by thread info block did not initialize, or failed at initialization
		literal		int 	ELP_CALLED = -8;
		literal		int 	ELP_BUSY = -9;
		literal		int 	ELP_IMPL = -10;
		literal		int 	ELP_ENOTIMP = -11;
		literal		int 	ELP_ERANGE = -12;
		literal		int 	ELP_ENOINIT = -13;

		//====================================================================Meta Functions

		//pass configuration file or string containing "*#".  The file/string is used to open the desired DLL types
		//returns number of device DLLs initialized
		static	INT_X	F_OpenInstancesAndFPAs(char * FileName);

		//pass type of DLL to use for search, C2000_DLL_TYPE, CC_DLL_TYPE, ARM_DLL_TYPE, MSP_DLL_TYPE, etc. Make sure selected API-DLL is present.
		//Any API-DLL will search for all types of FPAs connected.
		//return all FPAs connected to computer, with serial number and type etc., up to 64
		//returned text is same as F_Get_FPA_Label for each FPA.
		static	char *	F_DiscoverFPAs(char *type);

		//explicitly unloads all previously loaded device DLLs and frees associated data structures
		static	INT_X	F_CloseInstances();

		static	INT_X	F_Set_FPA_index(BYTE fpa);
		static	BYTE	F_Get_FPA_index(void);
		static	INT_X	F_Check_FPA_access(INT_X index);
		static	void	F_Enable_FPA_index(BYTE fpa);
		static	void	F_Disable_FPA_index(BYTE fpa);
		static	INT_X	F_LastStatus(BYTE fpa);
		static	INT_X	F_GenericDLLVer(void);
		static	INT_X	F_GenericTSDLLVer(void);
		static	INT_X	F_Get_FPA_SN(BYTE fpa);

		static	INT_X	F_Get_FPA_Label(BYTE fpa, BYTE * label);
		static  INT_X   F_Get_Power_Results(double *xs_adc);
		static  INT_X   F_Get_Last_Power_Results_data(double *xs_adc);
		static	INT_X   F_XS_Current_zeroing(int state, char *txt);
		static	INT_X	F_XS_Update_HW_State(BYTE mode, INT_X data);
		static	INT_X	F_XS_Clr_ADC_av_history();

		static	INT_X	F_GetProgressBar(BYTE fpa);//not covered by mutex; can be invoked while different function on same FPA is in progress (AutoProgram, etc.)
		static	INT_X	F_GetLastOpCode(BYTE fpa);//not covered by mutex; can be invoked while different function on same FPA is in progress (AutoProgram, etc.)
		static	INT_X	F_CancelAction(BYTE fpa);//not covered by mutex; can be invoked while different function on same FPA is in progress (AutoProgram, etc.)
		static	void	F_Trace_ON(void);
		static	void	F_Trace_OFF(void);
		static	INT_X	F_Set_Timeout_Short(int new_short_timeout);
		static	INT_X	F_Set_Timeout_Long(int new_long_timeout);
		
		//returns a char * representing the type of selected FPA
		// NULL if FPA out of range or selected FPA not initialized
		static	const char *	F_Get_FPA_type(BYTE fpa);

		//if debug is enabled then no functions will go to API DLLS
		//returns current status of debug_mode
		//if debug mode is enabled:
		//API DLL functions return ELP_IMPL if implemented for current FPA
		//API DLL functions return ELP_ENOTIMP if NOT implemented for current FPA   
		static	INT_X	F_Debug_Enable();

		//if debug is disabled then functions will go to API DLLS
		//returns current status of debug_mode
		static	INT_X	F_Debug_Disable();

		//====================================================================Generic Functions
		static	INT_X	F_Initialization(void);
		static	INT_X	F_Use_Config_INI(BYTE use);
		static	char *	F_Get_Config_Name_List(INT_X index);
		static	unsigned int F_Get_Config_Value_By_Name(char *name, int type);
		static	INT_X	F_Set_Config_Value_By_Name(char *name, unsigned int newValue);
		
		static	INT_X	F_SetConfig(INT_X index, INT_X  data);
		static	INT_X	F_GetConfig(INT_X index);
		static	void    F_Reset_Config(void);
		
		static	INT_X	F_Get_Device_Info(INT_X index);
		static	INT_X	F_Set_MCU_Name(char * MCU_name);
		static  void*   F_Search_MCU_Name(char * MCU_name_regex, char * Vendor_filter, int mode, int flags);
		static	char*	F_ARM_Get_MCU_Name_list(INT_X type, INT_X index);
		static	INT_X	F_ARM_Set_MCU_Family_Group(INT_X type, INT_X index);
		static	void	F_ReportMessage(char * text);
		static	char*	F_Report_Message(void);
		static	BYTE	F_GetReportMessageChar(INT_X index);
		static	INT_X	F_DLLTypeVer(void);
		static	INT_X	F_ConfigFileLoad(char * filename);
		static	INT_X	F_LoadFromImage(char * fullPath, char *password);
		static	INT_X	F_Power_Target(INT_X OnOff);
		static	INT_X	F_Reset_Target(void);
		static	INT_X	F_Get_Targets_Vcc(void);
		static	INT_X	F_Set_fpa_io_state(BYTE debug, BYTE reset, BYTE VccOn);
		static	INT_X	F_Set_fpa_IO(BYTE jtag, BYTE jtag_reset, BYTE EMU0, BYTE EMU1);
		static	INT_X	F_Get_Sector_Size(INT_X address);
		static	INT_X	F_Get_Lock_Bits(BYTE target_no);

		//====================================================================Data Buffer Functions
		static	INT_X	F_ReadCodeFile(char * FileName);
		static	INT_X	F_MSP_ReadCodeFile(INT_X file_format, char * FileName);
		static	INT_X	F_CC_ReadCodeFile(INT_X file_format, char * FileName);
		static	INT_X	F_AppendCodeFile(char *FileName);
		static	INT_X	F_Get_CodeCS(INT_X dest);
		static	INT_X	F_ReadPasswFile(char * FileName);
		static	INT_X	F_MSP_ReadPasswFile(INT_X file_format, char * FileName);				
		static	INT_X	F_Clr_Code_Buffer(void);

		static	INT_X	F_Put_Byte_to_Password_Buffer(INT_X addr, BYTE data);
		static	INT_X	F_Get_Byte_from_Password_Buffer(INT_X addr);
		
		static	INT_X	F_Put_Byte_to_Buffer(INT_X  addr, BYTE data);
		static	BYTE	F_Get_Byte_from_Buffer(INT_X  addr);
		static	INT_X	F_Put_Word_to_Buffer(INT_X addr, INT_X data);
		static	INT_X	F_Get_Word_from_Buffer(INT_X addr);
		static	void	F_Put_IEEEAddr64_to_Buffer(ULONG64 IEEEAddr);
		static	ULONG64 F_Get_IEEEAddr64_from_Buffer(void);
		static	INT_X	F_Put_IEEEAddr_Byte_to_Buffer(BYTE no, BYTE IEEEAddr);
		static	BYTE	F_Get_IEEEAddr_Byte_from_Buffer(BYTE no);
		static	INT_X	F_Copy_Buffer_to_direct_RAM(INT_X  start_addr, INT_X  size);
		static	INT_X	F_Copy_direct_RAM_to_Buffer(INT_X  start_addr, INT_X  size);
		
		static	INT_X	F_Put_Byte_to_Code_Buffer(INT_X  addr, BYTE data);
		static	INT_X	F_Get_Byte_from_Code_Buffer(INT_X  addr);
		static	INT_X	F_Put_Word_to_Code_Buffer(INT_X addr, INT_X data);
		static	INT_X	F_Get_Word_from_Code_Buffer(INT_X addr);
		
		static	INT_X	F_Put_Word_to_CSM_Buffer(INT_X dest, INT_X addr, INT_X data);
		static	INT_X	F_Get_Word_from_CSM_Buffer(INT_X dest, INT_X addr);
		
		static	INT_X	F_Put_Byte_to_Gang_Buffer(BYTE target_no, INT_X addr, BYTE data);
		static	BYTE 	F_Get_Byte_from_Gang_Buffer(BYTE target_no, INT_X addr);
		static	void	F_Put_IEEEAddr64_to_Gang_Buffer(BYTE target_no, ULONG64 IEEEAddr);
		static	ULONG64	F_Get_IEEEAddr64_from_Gang_Buffer(BYTE target_no);
		static	INT_X	F_Put_IEEEAddr_Byte_to_Gang_Buffer(BYTE target_no, BYTE no, BYTE IEEEAddr);
		static	BYTE	F_Get_IEEEAddr_Byte_from_Gang_Buffer(BYTE target_no, BYTE no);

		//====================================================================Encapsulated Functions
		static	INT_X	F_AutoProgram(INT_X mode);
		static  INT_X   F_Get_Error_No(BYTE fpa);
		static	INT_X	F_Verify_Lock_Bits();
		static	INT_X	F_Verify_Access_to_MCU();
		static	INT_X	F_Verify_CSM_Password();
		static	INT_X	F_VerifyFuseOrPassword();
		static	INT_X	F_Memory_Erase(INT_X mode);
		static	INT_X	F_Memory_Blank_Check(void);
		static	INT_X	F_Memory_Write(INT_X mode);
		static	INT_X	F_Memory_Verify(INT_X mode);
		static	INT_X	F_MSP_Memory_Read(unsigned char * data);
		static	INT_X	F_Memory_Read(void);
		static	INT_X	F_Gang_Flash_Read();
		static	INT_X	F_Write_IEEE_Address(void);
		static	INT_X	F_Read_IEEE_Address(void);
		static	INT_X	F_Copy_All_Flash_to_Buffer();
		static	INT_X	F_Restore_JTAG_Security_Fuse();
		static	INT_X	F_Clear_Locked_Device(void);
		static	INT_X	F_Lock_MCU(void);
		static	INT_X	F_Write_CSM_Password();
		static	INT_X	F_Write_Lock_Bits(void);

		//====================================================================Sequential Functions
		static	INT_X	F_Open_Target_Device(void);
		static	INT_X	F_Close_Target_Device(void);
		static	INT_X	F_Segment_Erase(INT_X  address);
		static	INT_X	F_Sectors_Blank_Check(INT_X  start_addr, INT_X  stop_addr);
		static	INT_X	F_Copy_Buffer_to_Flash(INT_X  start_addr, INT_X  size);
		static	INT_X	F_Copy_Flash_to_Buffer(INT_X  start_addr, INT_X  size);
		static	INT_X	F_Set_PC_and_RUN(INT_X  PC_addr);
		static	INT_X	F_CC_Set_PC_and_RUN(INT_X xram_en, INT_X  PC_addr);
		static	INT_X	F_ARM_Write_Byte_to_RAM(INT_X addr, BYTE data);
		static	INT_X	F_ARM_Write_Word16_to_RAM(INT_X addr, INT_X data);
		static	INT_X	F_ARM_Write_Word32_to_RAM(INT_X addr, INT_X data);
		static	INT_X	F_ARM_Write_Bytes_Block_to_RAM(INT_X start_addr, INT_X size, BYTE *data);
		static	INT_X	F_ARM_Read_Byte(INT_X addr);
		static	INT_X	F_ARM_Read_Word16(INT_X addr);
		static	INT_X	F_ARM_Read_Word32(INT_X addr);
		static	INT_X	F_ARM_Read_Bytes_Block(INT_X start_addr, INT_X size, BYTE *data);
		static	INT_X	F_Write_Debug_Register(void);
		static	INT_X	F_Write_Locking_Registers(void);
		static	INT_X	F_Blow_Fuse();
		static	INT_X	F_Adj_DCO_Frequency(INT_X freq_Hz);
		static	INT_X	F_Test_DCO_Frequency(INT_X DCO_constant);
		static	INT_X	F_Get_DCO_constant(BYTE target_no);
		static	INT_X	F_Set_DCO_constant(BYTE target_no);
		static	INT_X	F_GP_Test_DCO_Frequency();
		static	INT_X	F_Get_DCO_Freq_result(BYTE target_no);
		
		static	INT_X	F_Write_Byte_to_XRAM(INT_X  addr, BYTE data);
		static	INT_X	F_Read_Byte_from_XRAM(INT_X  addr);
		static	INT_X	F_Write_Byte_to_direct_RAM(INT_X  addr, BYTE data);
		static	INT_X	F_Read_Byte_from_direct_RAM(INT_X  addr);
		static	INT_X	F_Copy_Buffer_to_XRAM(INT_X  start_addr, INT_X  size);
		static	INT_X	F_Copy_XRAM_to_Buffer(INT_X  start_addr, INT_X  size);
		static	INT_X	F_Write_Word(INT_X addr, INT_X data);
		static	INT_X	F_Read_Word(INT_X addr);
		static	INT_X	F_Write_Byte(INT_X addr, BYTE data);
		static	BYTE 	F_Read_Byte(INT_X addr);
		static	INT_X	F_Memory_Write_Data(INT_X start_addr, INT_X size, unsigned char * data);
		static	INT_X	F_Memory_Read_Data(INT_X start_addr, INT_X size, unsigned char * data);
		static	INT_X	F_Copy_Buffer_to_RAM(INT_X start_addr, INT_X size);
		static	INT_X	F_Copy_RAM_to_Buffer(INT_X start_addr, INT_X size);
		static	INT_X	F_Write_Word_to_RAM(INT_X addr, INT_X data);

		static	INT_X	F_Get_MCU_Data(INT_X Type);
		static	INT_X	F_Capture_PC_Addr();
		static	INT_X	F_GP_Capture_PC_Addr(BYTE target_no);
		static	INT_X	F_Synch_CPU_JTAG();

		static	INT_X   F_Open_Comm(INT_X activeReset);
		static  INT_X	F_Soft_Reset_Target(void);
		static	INT_X	F_SetBoot0(INT_X BOOT0_override, INT_X BOOT0_value);
		
		static	INT_X	F_Copy_Gang_Buffer_to_XRAM(INT_X  start_addr, INT_X size);
		static	INT_X	F_Copy_XRAM_to_Gang_Buffer(INT_X  start_addr, INT_X size);
		static	INT_X	F_Copy_Gang_Buffer_to_direct_RAM(INT_X  start_addr, INT_X size);
		static	INT_X	F_Copy_direct_RAM_to_Gang_Buffer(INT_X  start_addr, INT_X size);
		static	INT_X	F_Copy_Gang_Buffer_to_Flash(INT_X start_addr, INT_X size);
		static	INT_X	F_Copy_Flash_to_Gang_Buffer(INT_X start_addr, INT_X size);
		static	INT_X	F_Copy_Gang_Buffer_to_RAM(INT_X start_addr, INT_X size);
		static	INT_X	F_Copy_RAM_to_Gang_Buffer(INT_X start_addr, INT_X size);
		static	INT_X	F_Gang_Read_Byte(BYTE target_no, INT_X addr);//any address, not only flash
		static	INT_X	F_Gang_Read_Word16(BYTE target_no, INT_X addr);//any address, not only flash
		static	INT_X	F_Gang_Read_Word32(BYTE target_no, INT_X addr);//any address, not only flash
		//INT_X	F_Gang_Read_Bytes_Block( INT_X addr, INT_X size, BYTE data[][GANG_SIZE] );//any address, not only flash, Generic-FPA-TS only
		static	INT_X	F_Copy_MCU_Data_to_Buffer(INT_X Type);
		static	INT_X	F_Get_MCU_Data_from_Buffer(BYTE target_no);
		
		static	INT_X	F_Get_Targets_Result();
		static	INT_X	F_Get_Active_Targets_Mask();

		//====================================================================Customized JTAG instruction
		static	void 	F_init_custom_jtag(INT_X state, INT_X Vcc_index);
		static	INT_X	F_custom_jtag_stream(INT_X mode, INT_X size, BYTE * data_out, BYTE * data_in);
		
		//====================================================================UART
		static	INT_X	F_Customize(INT_X dest, INT_X data);
		static	INT_X	F_Custom_Function(INT_X type);
	};
}

//Might have to change this to fit your directory structure
#include "Generic-FPA-TS.h"
#endif